Ramp: User schemas
11 Ramp schemas with complete fields and constraints.
← User operations · All schemas
Create a user invite — request body — body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
department_id | string | Optional | Unique identifier of the employee's department Format: uuid |
direct_manager_id | string | Optional | Unique identifier of the employee's direct manager Format: uuid |
email | string | Required within parent | The employee's email address Format: email |
first_name | string | Required within parent | First name of the employee Maximum length: 255 |
idempotency_key | string | Required within parent | an idempotency key is a unique value generated by the client which the server uses to recognize subsequent retries of the same request. To avoid collisions, we encourage clients to use random generated UUIDs. |
is_draft | boolean | Optional | When set to true, the user will be created as a draft. Draft users are not sent an invite email and must be explicitly activated later, which can be accomplished in-app or via the `POST /users/<string:user_id>/invite` resource. |
is_manager | boolean | Optional | Whether the employee is a manager |
last_name | string | Required within parent | Last name of the employee Maximum length: 255 |
location_id | string | Optional | Unique identifier of the employee's location Format: uuid |
role | string | Required within parent | The employee's role; It could be one of the following values: Admin, Cardholder, Bookkeeper; Note that Owner is not a invitable role. One of: AUDITOR, BUSINESS_ADMIN, BUSINESS_BOOKKEEPER, BUSINESS_OWNER, BUSINESS_USER, GUEST_USER, IT_ADMIN |
scheduled_deactivation_date | JSON | Optional | |
scheduled_deactivation_date (anyOf 1) | string | Alternative | The date when the user is scheduled to be deactivated. For guest users, this will automatically be set to 6 months from the invite creation date unless explicitly set to null. Cannot be set for admins or owners. Format: date |
scheduled_deactivation_date (anyOf 2) | null | Alternative |
Create a user invite — response body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
id | string | Required within parent | ID of the deferred task. Format: uuid |
Deactivate a user — response body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | Additional keys: not allowed |
Fetch a user — response body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
business_id | JSON | Required within parent | |
business_id (anyOf 1) | string | Alternative | Unique identifier of the company that the employee's working for. Format: uuid |
business_id (anyOf 2) | null | Alternative | |
custom_fields | array | Required within parent | A list of custom fields of the user. Read only: true |
custom_fields[] | Model | Each item | Expand Fetch a user — response body — custom fields item |
department_id | JSON | Required within parent | |
department_id (anyOf 1) | string | Alternative | Unique identifier of the employee's department Format: uuid |
department_id (anyOf 2) | null | Alternative | |
email | string | Optional | The employee's email address |
employee_id | JSON | Required within parent | |
employee_id (anyOf 1) | string | Alternative | An alternative identifier for an employee, coming from external systems, which can be used in place of an email. |
employee_id (anyOf 2) | null | Alternative | |
entity_id | JSON | Required within parent | |
entity_id (anyOf 1) | string | Alternative | Unique identifier of business entity user is associated with. Format: uuid |
entity_id (anyOf 2) | null | Alternative | |
first_name | string | Optional | First name of the employee |
id | string | Optional | Unique employee identifier Format: uuid |
is_manager | boolean | Required within parent | Whether the employee is a manager Read only: true |
last_name | string | Optional | Last name of the employee |
location_id | JSON | Required within parent | |
location_id (anyOf 1) | string | Alternative | Unique identifier of the employee's location Format: uuid |
location_id (anyOf 2) | null | Alternative | |
manager_id | JSON | Required within parent | |
manager_id (anyOf 1) | string | Alternative | Unique identifier of the employee's manager Format: uuid |
manager_id (anyOf 2) | null | Alternative | |
phone | JSON | Required within parent | |
phone (anyOf 1) | string | Alternative | The employee's phone number Read only: true |
phone (anyOf 2) | null | Alternative | |
role | string | Optional | The employee's role Known values: AUDITOR, BUSINESS_ADMIN, BUSINESS_BOOKKEEPER, BUSINESS_OWNER, BUSINESS_USER, GUEST_USER, IT_ADMIN, UNBUNDLED_ADMIN, UNBUNDLED_BOOKKEEPER, UNBUNDLED_OWNER, UNBUNDLED_USER |
scheduled_deactivation_date | JSON | Required within parent | |
scheduled_deactivation_date (anyOf 1) | string | Alternative | The date when the user is scheduled to be deactivated. Presented in ISO8601 format. Format: date-time |
scheduled_deactivation_date (anyOf 2) | null | Alternative | |
scheduled_invitation_date | JSON | Required within parent | |
scheduled_invitation_date (anyOf 1) | string | Alternative | The date when the user (currently in USER_DRAFT status) is scheduled to be invited to Ramp. Presented in ISO8601 format. Null if no invitation is scheduled. Format: date-time |
scheduled_invitation_date (anyOf 2) | null | Alternative | |
status | string | Required within parent | Known values: INVITE_EXPIRED, INVITE_PENDING, USER_ACTIVE, USER_DRAFT, USER_INACTIVE, USER_ONBOARDING, USER_SUSPENDED Read only: true |
Referenced models: Fetch a user — response body — custom fields item
Fetch a user — response body — custom fields item
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
name | string | Required within parent | Name of the custom field |
value | string | Required within parent | Value of the custom field |
Fetch deferred task status — response body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
context | Model | Optional | Expand Fetch deferred task status — response body — context Further context for the deferred task. |
data | Model | Optional | Expand Fetch deferred task status — response body — data Detailed data of the deferred task. |
id | string | Optional | Unique identifier of the deferred task. Format: uuid |
status | string | Optional | Status of the deferred task. It could be one of the following values: STARTED, IN_PROGRESS, ERROR, SUCCESS |
Referenced models: Fetch deferred task status — response body — context, Fetch deferred task status — response body — data
Fetch deferred task status — response body — context
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
acting_user_id | string | Optional | Unique identifier of the acting user that initiated the deferred task. Format: uuid |
Fetch deferred task status — response body — data
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
error | string | Optional | An error message if the deferred task fails |
user_id | string | Optional | The subject employee's ID of the deferred task. Format: uuid |
List users — response body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
data | array | Required within parent | Resources returned in this page. |
data[] | Model | Each item | Expand Fetch a user — response body |
page | Model | Required within parent | Expand List bills — response body — page Pagination details for this response. |
Referenced models: List bills — response body — page, Fetch a user — response body
Manage a user's invite lifecycle — request body — body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
action | string | Required within parent | The invite action to perform. SCHEDULE creates or updates a scheduled invitation (requires `invitation_time`). DESCHEDULE cancels any pending scheduled invitation. SEND_NOW immediately sends the user's invite. One of: DESCHEDULE, SCHEDULE, SEND_NOW |
invitation_time | string | Optional | The datetime at which the user should be invited. Required when `action` is SCHEDULE; ignored otherwise. Must be an ISO 8601 datetime with a timezone offset. Format: date-time |
Update a user — request body — body
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | |
auto_promote | boolean | Optional | Whether to automatically promote the users manager to manager. |
department_id | string | Optional | Unique identifier of the employee's department Format: uuid |
direct_manager_id | JSON | Optional | |
direct_manager_id (anyOf 1) | string | Alternative | Unique identifier of the employee's direct manager Format: uuid |
direct_manager_id (anyOf 2) | null | Alternative | |
first_name | string | Optional | Minimum length: 1 |
is_manager | boolean | Optional | Whether the employee is a manager |
last_name | string | Optional | Minimum length: 1 |
location_id | string | Optional | Unique identifier of the employee's location Format: uuid |
role | string | Optional | The employee's role; It could be one of the following values: Admin, Cardholder, Bookkeeper; Note that Owner is not a permissible value. One of: AUDITOR, BUSINESS_ADMIN, BUSINESS_BOOKKEEPER, BUSINESS_OWNER, BUSINESS_USER, GUEST_USER, IT_ADMIN |
scheduled_deactivation_date | JSON | Optional | |
scheduled_deactivation_date (anyOf 1) | string | Alternative | The date when the user is scheduled to be deactivated. Set to null to clear. Cannot be set for admins or owners. Format: date |
scheduled_deactivation_date (anyOf 2) | null | Alternative |